package com.sun.corba.se.impl.oa.toa;

import com.sun.corba.se.spi.protocol.LocalClientRequestDispatcher;
import org.omg.CORBA.portable.Delegate;
import com.sun.corba.se.impl.protocol.JIDLLocalCRDImpl;
import com.sun.corba.se.pept.protocol.ClientDelegate;
import com.sun.corba.se.spi.transport.CorbaContactInfoList;
import com.sun.corba.se.spi.oa.OADestroyed;
import org.omg.CORBA.Policy;
import com.sun.corba.se.spi.presentation.rmi.StubAdapter;
import com.sun.corba.se.impl.oa.NullServantImpl;
import com.sun.corba.se.spi.oa.OAInvocationInfo;
import org.omg.CORBA.Object;
import com.sun.corba.se.spi.copyobject.ObjectCopierFactory;
import com.sun.corba.se.impl.oa.poa.Policies;
import com.sun.corba.se.impl.ior.JIDLObjectKeyTemplate;
import com.sun.corba.se.spi.orb.ORB;
import com.sun.corba.se.spi.oa.ObjectAdapterBase;

public class TOAImpl extends ObjectAdapterBase implements TOA
{
    private TransientObjectManager servants;
    
    public TOAImpl(ORB orb, TransientObjectManager servants, String s) {
        super(orb);
        this.servants = servants;
        JIDLObjectKeyTemplate jidlObjectKeyTemplate = new JIDLObjectKeyTemplate(orb, 2, this.getORB().getTransientServerId());
        this.initializeTemplate(jidlObjectKeyTemplate, true, Policies.defaultPolicies, s, null, jidlObjectKeyTemplate.getObjectAdapterId());
    }
    
    public ObjectCopierFactory getObjectCopierFactory() {
        return this.getORB().getCopierManager().getDefaultObjectCopierFactory();
    }
    
    public org.omg.CORBA.Object getLocalServant(byte[] array) {
        return (org.omg.CORBA.Object)(org.omg.CORBA.Object)this.servants.lookupServant(array);
    }
    
    public void getInvocationServant(OAInvocationInfo oaInvocationInfo) {
        Object lookupServant = this.servants.lookupServant(oaInvocationInfo.id());
        if (lookupServant == null) {
            lookupServant = new NullServantImpl(this.lifecycleWrapper().nullServant());
        }
        oaInvocationInfo.setServant(lookupServant);
    }
    
    public void returnServant() {
    }
    
    public String[] getInterfaces(Object o, byte[] array) {
        return StubAdapter.getTypeIds(o);
    }
    
    public Policy getEffectivePolicy(int n) {
        return null;
    }
    
    public int getManagerId() {
        return -1;
    }
    
    public short getState() {
        return 1;
    }
    
    public void enter() throws OADestroyed {
    }
    
    public void exit() {
    }
    
    public void connect(org.omg.CORBA.Object servant) {
        Delegate delegate = StubAdapter.getDelegate(this.getCurrentFactory().make_object(StubAdapter.getTypeIds(servant)[0], this.servants.storeServant(servant, null)));
        LocalClientRequestDispatcher localClientRequestDispatcher = ((CorbaContactInfoList)((ClientDelegate)delegate).getContactInfoList()).getLocalClientRequestDispatcher();
        if ((localClientRequestDispatcher instanceof JIDLLocalCRDImpl)) {
            ((JIDLLocalCRDImpl)localClientRequestDispatcher).setServant(servant);
            StubAdapter.setDelegate(servant, delegate);
            return;
        }
        throw new RuntimeException("TOAImpl.connect can not be called on " + localClientRequestDispatcher);
    }
    
    public void disconnect(org.omg.CORBA.Object object) {
        LocalClientRequestDispatcher localClientRequestDispatcher = ((CorbaContactInfoList)((ClientDelegate)StubAdapter.getDelegate(object)).getContactInfoList()).getLocalClientRequestDispatcher();
        if ((localClientRequestDispatcher instanceof JIDLLocalCRDImpl)) {
            JIDLLocalCRDImpl jidlLocalCRDImpl = (JIDLLocalCRDImpl)localClientRequestDispatcher;
            this.servants.deleteServant(jidlLocalCRDImpl.getObjectId());
            jidlLocalCRDImpl.unexport();
            return;
        }
        throw new RuntimeException("TOAImpl.disconnect can not be called on " + localClientRequestDispatcher);
    }
}
